//   -
//   ,    4-  ( )
//     -     
//     --
//         4  8 
//    ,        
//     !     ...
// (c) Proteus 2006
//
// 12:06 27.02.2009        
//     
//
//    
// 1  )          
// 2  )      ( 64 )  
// 2.2)      ,
//            
//               

#include<stdio.h>
#include<string.h>
#include<algorithm>  // swap

typedef unsigned char BYTE;
typedef unsigned long DWORD;

char t[10000];
char p[30];
struct{DWORD sig; int offset;}sig_list[30];
int sig_count;

int offset[256];

void Sig_init()
{
	int n,m; 
	sig_count=strlen(p)-3;
	for(n=0; n<sig_count; n++) sig_list[n].offset=n,sig_list[n].sig=*(DWORD*)&p[n];
	for(n=0; n<sig_count; n++) //sort
		for(m=n+1; m<sig_count; m++) 
			if(sig_list[n].sig>sig_list[m].sig) std::swap(sig_list[n],sig_list[m]);
}

int GetSig(DWORD s)
{
	int a,b,c;
	a=0;
	b=sig_count-1;
	while(a<=b) {
		c=(a+b)/2;
		if(sig_list[c].sig==s) return sig_list[c].offset;
		if(sig_list[c].sig>s) b=c-1; else a=c+1;
	}
	return -4;
}



void main()
{
	int n,m,x;
	strcpy(t,"bbbtpabxa12bbbbbbbaaaxxxbaxbaxbxaxpbctbxabpqxctbpqtptpabxab12abxab");
	strcpy(p,"tpabxab12");

	int len=strlen(p);
	Sig_init();
	for(n=0; n<256; n++) offset[n]=len;
	for(n=0; n<len-1; n++) offset[(BYTE)p[n]]=len-n-1; offset[(BYTE)p[len-1]]=1;

	for(n=0; n<=strlen(t)-len;) {
		printf("%s\n",t);
		for(m=0; m<n; m++) putchar(' '); printf("%s\n",p);

		m=(n+len-4)&~3;

		while(m>=n) {
			x=GetSig(*(DWORD*)&t[m]); 
			if(x+n!=m) break;
			m-=sizeof(DWORD);
		}
		if(m>=n) {n+=(m-n)-x;continue;}
		for(m=0; m<x; m++) if((BYTE)t[n+m]!=(BYTE)p[m]) break;
		if(m==x) {for(m=len&~3; m<len; m++) if((BYTE)t[n+m]!=(BYTE)p[m]) break;}
		if(m==len) { printf("Ok :%d\n",n); break;}
		m=(BYTE)t[n+len]; if(!m) break;
		n+=offset[m];
	}
	getchar();
}
